#! /usr/bin/env python
# -*- coding: utf_8 -*-

from panda3d.core import *
from direct.gui.DirectGui import *
from direct.interval.IntervalGlobal import *
from libs.InteraciveScene import InteractiveScene
from libs.MousePicker import MousePicker
import direct.directbase.DirectStart

base.disableMouse()
base.camera.setPos(0,-8,8)
base.camera.lookAt(0,0,0)

plnp1 = render.attachNewNode(PointLight('plight1'))
plnp1.setPos(5, -10, 5)
plnp2 = render.attachNewNode(PointLight('plight2'))
plnp2.setPos(5, 0, -5)
plnp2.node().setColor(Vec4(1,0,0,1))
render.setLight(plnp1)


# MousePicker generates events for InteractiveScene (see lib/MousePicker.py)
mp = MousePicker()

# Create the scene object and pass a list of event types
scene = InteractiveScene(events = ['click', 'rollin', 'rollout'])

# Some custom functions to do something
# evtInfo - Required to provide event information
def color(evtInfo, obj, r, g, b):
    scene.root.find('**/'+obj).setColor(float(r),float(g),float(b))
def light(evtInfo, opt = 'on'):
    if opt == 'on': render.setLight(plnp2)
    elif opt == 'off': render.clearLight(plnp2)
# Register new functions
scene.functions['color'] = color
scene.functions['light'] = light

# Load and analze scene file
scene.process(loader.loadModel('scene'))

# Set event in runtime
txt = 'loop[sh:Key 1:0:1:0.5][sh:Key 1:1:0:0.5][sh:Key 2:0:1:0.5][sh:Key 2:1:0:0.5]'
scene.setEvent('Cylinder.004', 'rollin', txt)
txt = 'play[fn:_stopObj:_self]'
scene.setEvent('Cylinder.004', 'rollout', txt)

run()
