#! /usr/bin/env python
# -*- coding: utf_8 -*-

from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import CollisionTraverser,CollisionNode
from pandac.PandaModules import CollisionHandlerQueue,CollisionRay
from pandac.PandaModules import BitMask32
from random import randint, random

class MousePicker(DirectObject):
    def __init__(self):
        #self.picker         = CollisionTraverser()
        base.cTrav          = CollisionTraverser()
        self.pickerQ        = CollisionHandlerQueue()
        self.pickerCollN    = CollisionNode('mouseRay')
        self.pickerCamN     = base.camera.attachNewNode(self.pickerCollN)
        self.pickerCollN.setFromCollideMask(BitMask32.bit(1))
        self.pickerRay = CollisionRay()
        self.pickerCollN.addSolid(self.pickerRay)
        base.cTrav.addCollider(self.pickerCamN, self.pickerQ)
        #base.cTrav.showCollisions(base.render)           
        self.objectUnderCursor = None
        self.accept('mouse1',self.pick)
        taskMgr.add(self.process, 'Mouse picker process')
    
    def pick(self):
        if self.objectUnderCursor:
            messenger.send('interactive-scene-event',[self.objectUnderCursor.getName(),'click'])
    
    def process(self,task):
        if base.mouseWatcherNode.hasMouse():
            mpos = base.mouseWatcherNode.getMouse()      
            self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
            #self.picker.traverse(base.render)
            if self.pickerQ.getNumEntries() > 0:
                self.pickerQ.sortEntries()
                firstNode = self.pickerQ.getEntry(0).getIntoNode()
                if firstNode != self.objectUnderCursor:
                    if self.objectUnderCursor:
                        messenger.send('interactive-scene-event',[self.objectUnderCursor.getName(),'rollout'])
                        #print 'Rollout', self.objectUnderCursor.getName()
                    self.objectUnderCursor = firstNode
                    messenger.send('interactive-scene-event',[self.objectUnderCursor.getName(),'rollin'])
                    #print 'Rollin', self.objectUnderCursor.getName()
            else:
                if self.objectUnderCursor:
                    messenger.send('interactive-scene-event',[self.objectUnderCursor.getName(),'rollout'])
                    #print 'Rollout', self.objectUnderCursor.getName()
                    self.objectUnderCursor = None

        return task.cont
